;behaves $025.
;Better timer passable block, By GreenHammerBro.

;This block will be solid and become passable if a specific timer is not zero
;(meaning that the timer is running). Unlike other conditional solid/passable
;blocks hosted on smwc, this one is impossable to make this block solid while
;mario is inside. By keeping the timer from hitting 00, it will last endlessly
;until mario gets off this block. Very useful to make it imposable to zip
;downwards extremly fast and through the walls/floor.

!trigger_ram	= $14AD

;^what type of trigger makes this passable:
;$14AD = blue p-switch
;$14AE = silver p-switch
;$1490 = star power

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP SpriteV
JMP SpriteH : JMP MarioCape : JMP MarioFireBall : JMP TopCorner
JMP BodyInside : JMP HeadInside

TopCorner:
MarioAbove:
MarioSide:
HeadInside:
BodyInside:
MarioBelow:

	LDA !trigger_ram	;\if timer is out
	BEQ solid		;/then be solid.
	CMP #$03		;\if the timer goes near 00,
	BCS return		;|then prevent it from reaching 00 and become solid
	CLC : ADC #$03		;|(so it doesn't lower the timer if mario
	STA !trigger_ram	;|has a lot of time). I use "add" so it still has
				;/the timer-based animation if you have a star. (just in case)
	RTL
solid:
	LDY #$01
	LDA #$30
	STA $1693
MarioFireBall:
SpriteV:
SpriteH:
MarioCape:
return:
RTL
